"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useIonFormState = exports.IonFormItemOptions = exports.IonFormItem = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var react_2 = require("@ionic/react");
function IonFormItem(props) {
    var renderLabel = props.renderLabel || exports.IonFormItemOptions.Label;
    function onIonChange(e) {
        var _a;
        var value = 'checked' in e.detail ? e.detail.checked : e.detail.value;
        if (props.mapValue) {
            value = props.mapValue(e, props.state[props.name]);
        }
        props.setState(__assign(__assign({}, props.state), (_a = {}, _a[props.name] = value, _a)));
    }
    return (jsx_runtime_1.jsxs(react_2.IonItem, { children: [renderLabel(props), props.renderContent({
                name: props.name.toString(),
                onIonChange: onIonChange,
                value: props.state[props.name],
                checked: props.state[props.name],
            })] }, void 0));
}
exports.IonFormItem = IonFormItem;
exports.IonFormItemOptions = {
    Label: function Label(props) {
        var label = props.label || props.name.toString();
        return jsx_runtime_1.jsx(react_2.IonLabel, { children: label }, void 0);
    },
};
function useIonFormState(initialValue) {
    if (initialValue === void 0) { initialValue = {}; }
    var _a = react_1.useState(initialValue), state = _a[0], setState = _a[1];
    function reset() {
        setState(initialValue);
    }
    return {
        state: state,
        setState: setState,
        reset: reset,
        item: function (props) {
            return jsx_runtime_1.jsx(IonFormItem, __assign({ state: state, setState: setState }, props), void 0);
        },
    };
}
exports.useIonFormState = useIonFormState;
//# sourceMappingURL=use-ion-form-state.js.map